require File.join(File.dirname(__FILE__), 'helpers')
%w(sinatra/base active_support/inflector).each { |lib| require lib }

module Artifact

  class App < Sinatra::Base

    set :sessions, true
    set :method_override, true
    set :views, File.join(settings.root, 'views')

    use Rack::ShowExceptions
    use Rack::Static,
      :urls => %w(/css /img /js),
      :root => File.join(settings.root, 'public')

    helpers do
      # include Rack::Utils # provides escape, parse_query and unescape
      # include Sinatra::ContentFor
      include Helpers
      def logger; LOGGER; end
    end

    error do
      if request.env['sinatra.error'].class.name['DocumentNotFound']
        not_found
      else
        erb :'errors/500', :layout => false
      end
    end

    not_found do
      not_found
    end

    private

    def current_user
      {
        :name  => Artifact.config.author_name,
        :email => Artifact.config.author_email
      }
    end

    def not_found
      erb :'errors/404', :layout => false
    end

  end

end
