require File.join(File.dirname(__FILE__), 'app')

module Artifact

  def self.files
    @files ||= Tree.new(config.root)
  end

  class Files < App

    get '/' do
      redirect to('/files')
    end

    get '/files' do
      @files = Artifact.files.all
      view 'files/index'
    end

    get '/files/new' do
      view 'files/new'
    end

    post '/files/create' do
      @file = Artifact.files.new(params[:path])
      @file.update(params[:content], params[:meta])
      redirect to('/')
    end

    get '/files/edit/*' do
      get_file
      view 'files/edit'
    end

    post '/files/update/*' do
      get_file
      @file.update(params[:content], params[:meta])

      if params[:submit] and params[:submit][/push/i]
        return redirect to("/commit/#{params[:splat][0]}")
      end

      redirect to('/')
    end

    get '/commit/*' do
      get_file
      Artifact.repo.save(@file.full_path, current_user)
      redirect to('/')
    end

    private

    def get_file
      Artifact.open_file(params[:splat][0]) or raise 'File not found!'
    end

  end

end
